﻿@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using System.Web.UI.WebControls;

@Html.DevExpress().GridView(
settings =>
{
    settings.Name = "GridShipmentInquiry";
    settings.KeyFieldName = "BOOKING_NO;SHIPMENT_NO";
    settings.CallbackRouteValues = new { Controller = "ShipmentInquiry", Action = "GetShipmentInquiryCallBack" };
    settings.Width = System.Web.UI.WebControls.Unit.Percentage(100);
    settings.ControlStyle.Paddings.Padding = System.Web.UI.WebControls.Unit.Pixel(0);
    settings.ControlStyle.Border.BorderWidth = System.Web.UI.WebControls.Unit.Pixel(0);
    settings.ControlStyle.BorderBottom.BorderWidth = System.Web.UI.WebControls.Unit.Pixel(1);

    settings.ClientSideEvents.BeginCallback = "GridShipmentInquiryOnBeginCallback";
    settings.ClientSideEvents.EndCallback = "GridShipmentInquiryOnEndCallback";

    settings.CommandColumn.Visible = true;
    settings.CommandColumn.ShowSelectCheckbox = true;
    settings.CommandColumn.Width = System.Web.UI.WebControls.Unit.Pixel(50);
    settings.ClientSideEvents.SelectionChanged = "GridShipmentInquiry_SelectionChanged";

    settings.SettingsEditing.Mode = GridViewEditingMode.Inline;
    settings.SettingsPager.Visible = true;
    settings.Settings.ShowFilterRowMenu = false;
    settings.Settings.ShowFilterRow = false;

    settings.SettingsPager.FirstPageButton.Visible = true;
    settings.SettingsPager.LastPageButton.Visible = true;
    settings.SettingsPager.ShowNumericButtons = true;
    settings.SettingsPager.Position = System.Web.UI.WebControls.PagerPosition.Bottom;
    settings.SettingsPager.PageSizeItemSettings.Visible = true;
    settings.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "25", "50", "100" };
    settings.SettingsPager.PageSize = 10;
    settings.SettingsPager.PageSizeItemSettings.Caption = "View per page";

    settings.Settings.VerticalScrollBarMode = ScrollBarMode.Auto;
    settings.Settings.HorizontalScrollBarMode = ScrollBarMode.Auto;
    settings.Settings.VerticalScrollableHeight = 370;

    settings.CommandColumn.SetHeaderTemplateContent(c =>
    {
        if (c.Column.VisibleIndex == 0)
        {
            Html.DevExpress().CheckBox(
                chckBox =>
                {
                    chckBox.Name = "chckBox";
                    chckBox.Width = System.Web.UI.WebControls.Unit.Percentage(100);
                    chckBox.Properties.ClientSideEvents.CheckedChanged = "function(s, e){ GridShipmentInquiry.SelectAllRowsOnPage(chckBox.GetChecked());}";
                }
            ).Render();
        }
    });

    settings.Columns.Add(
    column =>
    {
        column.FieldName = "STATUS";
        column.Caption = "Status";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.TextBox;
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(100);
    });
    settings.Columns.Add(
        column =>
        {
            column.FieldName = "COMPLETENESS";
            column.Caption = "Completeness";
            column.Width = 100;
            column.CellStyle.Wrap = DefaultBoolean.True;
            column.ColumnType = MVCxGridViewColumnType.TextBox;
            column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
            column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
            column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        });
    settings.Columns.Add(
        column =>
        {
            column.FieldName = "BOOKING_NO";
            column.Caption = "Booking No";
            column.CellStyle.Wrap = DefaultBoolean.True;
            column.ColumnType = MVCxGridViewColumnType.TextBox;
            column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
            column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
            column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
            column.Width = Unit.Pixel(115);
            column.SetDataItemTemplateContent(container =>
            {
                Html.DevExpress().HyperLink(hlSettings =>
                {
                    hlSettings.Name = string.Format("bn_{0}", (container as GridViewDataItemTemplateContainer).VisibleIndex);
                    hlSettings.ControlStyle.Font.Underline = true;
                    hlSettings.NavigateUrl = "javascript:void(0)";
                    hlSettings.Width = Unit.Percentage(100);
                    hlSettings.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ OnDetailLinkClicked('{0}','{1}', '{2}');}}",
                        "DETAIL",
                        Convert.ToString(DataBinder.Eval(container.DataItem, "BOOKING_NO")),
                        Convert.ToString(DataBinder.Eval(container.DataItem, "SHIPMENT_NO"))
                    );
                    hlSettings.Properties.Text = (container as GridViewDataItemTemplateContainer).Text;
                }).Render();
            });
            column.SetEditItemTemplateContent(container =>
            {
                Html.DevExpress().TextBox(DateSetting =>
                {
                    DateSetting.Name = "IN_EDIT_BOOKING_NO";
                    DateSetting.Width = Unit.Percentage(100);
                    DateSetting.ClientEnabled = false;
                }).Bind(DataBinder.Eval(container.DataItem, container.Column.FieldName)).Render();
            });
        });
    settings.Columns.Add(
        column =>
        {
            column.FieldName = "SHIPMENT_NO";
            column.Caption = "Shipment No";
            column.CellStyle.Wrap = DefaultBoolean.True;
            column.ColumnType = MVCxGridViewColumnType.TextBox;
            column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
            column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
            column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
            column.Width = Unit.Pixel(115);
            column.SetDataItemTemplateContent(container =>
            {
                Html.DevExpress().HyperLink(hlSettings =>
                {
                    hlSettings.Name = string.Format("sn_{0}", (container as GridViewDataItemTemplateContainer).VisibleIndex);
                    hlSettings.ControlStyle.Font.Underline = true;
                    hlSettings.NavigateUrl = "javascript:void(0)";
                    hlSettings.Width = Unit.Percentage(100);
                    hlSettings.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ OnDetailLinkClicked('{0}','{1}', '{2}');}}",
                        "PRICE",
                        Convert.ToString(DataBinder.Eval(container.DataItem, "BOOKING_NO")),
                        Convert.ToString(DataBinder.Eval(container.DataItem, "SHIPMENT_NO"))
                    );
                    hlSettings.Properties.Text = (container as GridViewDataItemTemplateContainer).Text;
                }).Render();
            });
            column.SetEditItemTemplateContent(container =>
            {
                Html.DevExpress().TextBox(DateSetting =>
                {
                    DateSetting.Name = "IN_EDIT_SHIPMENT_NO";
                    DateSetting.Width = Unit.Percentage(100);
                    DateSetting.ClientEnabled = false;
                }).Bind(DataBinder.Eval(container.DataItem, container.Column.FieldName)).Render();
            });
        });
    settings.Columns.Add(
    column =>
    {
        column.FieldName = "BUYER_CD";
        column.Caption = "Buyer Code";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.TextBox;
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(100);
    });
    settings.Columns.Add(
    column =>
    {
        column.FieldName = "ETD";
        column.Caption = "ETD";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.DateEdit;
        column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(100);
    });
    settings.Columns.Add(
    column =>
    {
        column.FieldName = "ATD";
        column.Caption = "ATD";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.DateEdit;
        column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(100);
        column.SetEditItemTemplateContent(container =>
        {
            Html.DevExpress().DateEdit(DateSetting =>
            {
                DateSetting.Name = "IN_EDIT_ATD";
                DateSetting.Properties.EditFormatString = "dd.MM.yyyy";
                DateSetting.Width = Unit.Percentage(100);
                //DateSetting.Properties.ClientSideEvents.ValueChanged = string.Format("function(s,e){{ VALID_FROM_OnValueChanged(s,'{0}'); }}", container.VisibleIndex);
                //if (DataBinder.Eval(container.DataItem, container.Column.FieldName) != null)
                //{
                //    DateSetting.ReadOnly = true;
                //}
            }).Bind(DataBinder.Eval(container.DataItem, container.Column.FieldName)).Render();
        });
    });
    settings.Columns.Add(
    column =>
    {
        column.FieldName = "ATD_ADDED_BY";
        column.Caption = "ATD Added By";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.HeaderStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.TextBox;
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(150);
    });
    settings.Columns.Add(
    column =>
    {
        column.FieldName = "CONTAINER_QTY";
        column.Caption = "Total Container per Shipment";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.HeaderStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.TextBox;
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(150);
    });
    settings.Columns.Add(
    column =>
    {
        column.FieldName = "EXCHANGE_RATE";
        column.Caption = "Exchange Rate";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.TextBox;
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(100);
    });
    settings.Columns.Add(
    column =>
    {
        column.FieldName = "EXCHANGE_RATE_DT";
        column.Caption = "Exchange Rate Date";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.DateEdit;
        column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(150);
    });
    settings.Columns.Add(
    column =>
    {
        column.FieldName = "TOTAL_AMOUNT";
        column.Caption = "Total Amount";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.TextBox;
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(100);
    });
    settings.Columns.Add(
    column =>
    {
        column.FieldName = "APPROVED_DT";
        column.Caption = "Approved Date";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.DateEdit;
        column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(100);
    });
    settings.Columns.Add(
    column =>
    {
        column.FieldName = "APPROVED_BY";
        column.Caption = "Approved By";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.TextBox;
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(100);
    });
    settings.Columns.Add(
    column =>
    {
        column.FieldName = "FA";
        column.Caption = "FA";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.TextBox;
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(100);
    });
    settings.Columns.Add(
    column =>
    {
        column.FieldName = "FA_VENDOR_CD";
        column.Caption = "FA Vendor CD.";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.TextBox;
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(100);
    });
    settings.Columns.Add(
    column =>
    {
        column.FieldName = "SA";
        column.Caption = "SA";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.TextBox;
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(100);
    });
    settings.Columns.Add(
    column =>
    {
        column.FieldName = "SA_VENDOR_CD";
        column.Caption = "SA Vendor CD.";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.TextBox;
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(100);
    });
    settings.Columns.Add(
    column =>
    {
        column.FieldName = "FEEDER_VESSEL";
        column.Caption = "Feeder Vessel";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.TextBox;
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(100);
    });
    settings.Columns.Add(
    column =>
    {
        column.FieldName = "CREATED_BY";
        column.Caption = "Created By";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.TextBox;
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(100);
    });
    settings.Columns.Add(
    column =>
    {
        column.FieldName = "CREATED_DT";
        column.Caption = "Created Date";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.DateEdit;
        column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(100);
    });
    settings.Columns.Add(
    column =>
    {
        column.FieldName = "CHANGED_BY";
        column.Caption = "Changed By";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.TextBox;
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(100);
    });
    settings.Columns.Add(
    column =>
    {
        column.FieldName = "CHANGED_DT";
        column.Caption = "Changed Date";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.DateEdit;
        column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(100);
    });

    settings.CellEditorInitialize = (object sender, ASPxGridViewEditorEventArgs e) =>
    {
        MVCxGridView gridView = (MVCxGridView)sender;

        if (e.Column.FieldName == "STATUS")
        {
            e.Editor.ClientEnabled = false;
        }
        if (e.Column.FieldName == "COMPLETENESS")
        {
            e.Editor.ClientEnabled = false;
        }
        if (e.Column.FieldName == "BOOKING_NO")
        {
            e.Editor.ClientEnabled = false;
        }
        if (e.Column.FieldName == "SHIPMENT_NO")
        {
            e.Editor.ClientEnabled = false;
        }
        if (e.Column.FieldName == "BUYER_CD")
        {
            e.Editor.ClientEnabled = false;
        }
        if (e.Column.FieldName == "ETD")
        {
            e.Editor.ClientEnabled = false;
        }
        if (e.Column.FieldName == "ATD")
        {
            e.Editor.ClientEnabled = true;
        }
        if (e.Column.FieldName == "ATD_ADDED_BY")
        {
            e.Editor.ClientEnabled = false;
        }
        if (e.Column.FieldName == "CONTAINER_QTY")
        {
            e.Editor.ClientEnabled = false;
        }
        if (e.Column.FieldName == "EXCHANGE_RATE")
        {
            e.Editor.ClientEnabled = false;
        }
        if (e.Column.FieldName == "EXCHANGE_RATE_DT")
        {
            e.Editor.ClientEnabled = false;
        }
        if (e.Column.FieldName == "TOTAL_AMOUNT")
        {
            e.Editor.ClientEnabled = false;
        }
        if (e.Column.FieldName == "APPROVED_DT")
        {
            e.Editor.ClientEnabled = false;
        }
        if (e.Column.FieldName == "APPROVED_BY")
        {
            e.Editor.ClientEnabled = false;
        }
        if (e.Column.FieldName == "FA")
        {
            e.Editor.ClientEnabled = false;
        }
        if (e.Column.FieldName == "FA_VENDOR_CD")
        {
            e.Editor.ClientEnabled = false;
        }
        if (e.Column.FieldName == "SA")
        {
            e.Editor.ClientEnabled = false;
        }
        if (e.Column.FieldName == "SA_VENDOR_CD")
        {
            e.Editor.ClientEnabled = false;
        }
        if (e.Column.FieldName == "FEEDER_VESSEL")
        {
            e.Editor.ClientEnabled = false;
        }
        if (e.Column.FieldName == "CREATED_BY")
        {
            e.Editor.ClientEnabled = false;
        }
        if (e.Column.FieldName == "CREATED_DT")
        {
            e.Editor.ClientEnabled = false;
        }
        if (e.Column.FieldName == "CHANGED_BY")
        {
            e.Editor.ClientEnabled = false;
        }
        if (e.Column.FieldName == "CHANGED_DT")
        {
            e.Editor.ClientEnabled = false;
        }
    };
    
    settings.CommandButtonInitialize = (object sender, ASPxGridViewCommandButtonEventArgs e) =>
    {
        if (e.ButtonType == ColumnCommandButtonType.Update)
        {
            e.Visible = false;
        }
        if (e.ButtonType == ColumnCommandButtonType.Cancel)
        {
            e.Visible = false;
        }
    };
}).Bind(Model).GetHtml()